newTalentType{ type="combat", name = "combat", description = "Talents used by all classes." }

newTalent{
	name = "Leap",
	type = {"combat", 1},
	points = 1,
	cooldown = 7,
	stamina = 10,
	range = function(self, t)
		return math.ceil(1 + self:getStr()/7)
	end,
	action = function(self, t)
		local tg = {type="bolt", range=self:getTalentRange(t)}
		local x, y, target = self:getTarget(tg)
		if not x or not y then return nil end

		if math.floor(core.fov.distance(self.x, self.y, x, y)) > self:getTalentRange(t) then return nil end

		if target then return nil end

		self:move(x, y, true)
		return true
	end,
	info = function(self, t)
		return ([[Jump up to %d spaces away.]]):format(self:getTalentRange(t))
	end,
}

newTalent{
	name = "Regenerate I",
	type = {"combat", 1},
	mode = "passive",
	points = 1,
	on_learn = function(self, t)
		self.stamina_regen = self.stamina_regen + 0.5
	end,
	on_unlearn = function(self, t)
		self.stamina_regen = self.stamina_regen - 0.5
	end,
	info = function(self, t)
		return ([[You are able to generate stamina faster faster (+0.5 stamina/turn).]])
	end,
}

newTalent{
	name = "Regenerate II",
	type = {"combat", 1},
	mode = "passive",
	points = 1,
	require = { talent = { Talents.T_REGENERATE_I }, },
	on_learn = function(self, t)
		self.stamina_regen = self.stamina_regen + 0.5
	end,
	on_unlearn = function(self, t)
		self.stamina_regen = self.stamina_regen - 0.5
	end,
	info = function(self, t)
		return ([[You are able to generate stamina faster faster (+0.5 stamina/turn).]])
	end,
}

newTalent{
	name = "Regenerate III",
	type = {"combat", 1},
	mode = "passive",
	points = 1,
	require = { talent = { Talents.T_REGENERATE_II }, },
	on_learn = function(self, t)
		self.stamina_regen = self.stamina_regen + 0.5
	end,
	on_unlearn = function(self, t)
		self.stamina_regen = self.stamina_regen - 0.5
	end,
	info = function(self, t)
		return ([[You are able to generate stamina faster faster (+0.5 stamina/turn).]])
	end,
}